﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Common
{
    /// <summary>
    /// 连接类型
    /// </summary>
    public enum EnumGetConnectStringType { Config = 1, DataBase = 2, Default = 0 }

    public enum EnumDeviceStatus { 正常 = 10, 故障 = 20, 报废 = 30, 待新增 = 40, 新增被拒 = 50, 返厂 = 60, 删除 = 70 }

    /// <summary>
    /// token的返回值
    /// </summary>
    public enum EnumSuccStat
    {
        成功 = 0,
        失败 = 1
    }
    /// <summary>
    /// 枪状态
    /// </summary>
    /// <summary>
    /// 充电机状态
    /// </summary>
    public enum EnumChargeStatus { 待机 = 0, 充电 = 1, 故障 = 2, 启动中 = 3, 暂停 = 4, 限制 = 5, 离线 = 6, 切换中 = 7, 放电 = 8 }

    /// <summary>
    /// 连接状态
    /// </summary>
    public enum EnumConnectStatus
    {
        断开 = 0, 连接 = 1, 插枪且车辆未确认 = 2, 插枪且车辆确认 = 4, 半连接 = 5
    }
    public enum EnumGunStatus
    {
        启动中 = -2, 不存在 = -1, 放电 = 0, 充电中 = 1, 连接 = 2, 故障 = 3, 未插枪 = 4, 离线 = 5, 暂停 = 6, 充满 = 7, 订单结束 = 8, 正在启动 = 11
    }
    public enum EnumDeviceTypes { 虚拟设备层 = 0, 集控 = 1, 电表 = 2, CCU = 3, PDU = 4, 枪头 = 5, 模块 = 6 }


    /// <summary>
    /// 设备认证失败原因
    /// </summary>
    public enum EnumEquipAuthReason
    {
        无 = 0,
        此设备尚未插枪 = 1,
        设备检测失败 = 2,
        其他 = 3
    }

    ///启动失败原因
    public enum EnumStartFailReason
    {
        无 = 0,
        此设备不存在 = 1,
        此设备离线 = 2,
        其他 = 3,
        找不到对应的运营商ID = 4,
        找不到对应的运营商信息 = 5,
        非小桔设备 = 6
    }

    /// <summary>
    /// 设备子类
    /// </summary>
    public enum EnumSubDeviceType { 直流充电枪 = 501, 交流充电枪 = 502, 充电弓 = 503, 无线充电枪 = 504 }

    public enum EnumApplyStatus { 待审核 = 10, 通过 = 20, 拒绝 = 30, 超时 = 40, 未提交 = 50 }

    public enum EnumDeviceChangeTypes { 新增 = 10, 迁移 = 20, 更换 = 30, 报废 = 40, 返厂 = 50, 删除 = 60 }

    /// <summary>
    /// 信号标准化ID
    /// </summary>
    public enum EnumSignalID
    {
        集控_通讯状态 = 0,
        集控_烟感报警器 = 1700,
        集控_门磁报警器 = 1701,
        集控_子站温度 = 1702,
        集控_站湿度 = 1703,
        集控_子站温度2 = 1704,
        集控_站湿度2 = 1705,

        电表_通讯状态 = 0,
        电表_A相电压 = 2301,
        电表_B相电压 = 2302,
        电表_C相电压 = 2303,
        电表_A相电流 = 2304,
        电表_B相电流 = 2305,
        电表_C相电流 = 2306,
        电表_总有功功率 = 2307,
        电表_总无功功率 = 2308,
        电表_总功率因数 = 2309,
        电表_零线电流 = 2310,
        电表_电压不平衡率 = 2311,
        电表_电流不平衡率 = 2312,
        电表_谐波畸变率 = 2313,
        电表_A相有功功率 = 2314,
        电表_B相有功功率 = 2315,
        电表_C相有功功率 = 2316,
        电表_A相无功功率 = 2317,
        电表_B相无功功率 = 2318,
        电表_C相无功功率 = 2319,
        电表_A相功率因数 = 2320,
        电表_B相功率因数 = 2321,
        电表_C相功率因数 = 2322,
        电表_总正向有功电能 = 2323,
        电表_总反向有功电能 = 2324,
        电表_感性无功电能 = 2325,
        电表_容性无功电能 = 2326,

        CCU_通讯状态 = 0,
        CCU_直流柜系统运行状态 = 3001,
        CCU_输入接触器状态 = 3002,
        CCU_联动接触器状态 = 3003,
        CCU_系统机型 = 3004,
        CCU_总运行时间 = 3301,
        CCU_环境温度 = 3302,
        CCU_直流柜额定输出功率 = 3303,
        CCU_直流柜当前输出功率 = 3304,

        PDU_通讯状态 = 0,
        PDU_运行状态 = 4001,
        PDU_输出电压 = 4301,
        PDU_输出电流 = 4302,
        PDU_环境温度 = 4303,
        PDU_散热器温度 = 4304,
        PDU_总运行时间 = 4305,
        PDU_切换次数 = 4306,
        PDU_电能表读数 = 4307,
        PDU_绝缘电阻负对地阻值 = 4308,
        PDU_绝缘电阻正对地阻值 = 4309,
        PDU_设置模块输出电压 = 4310,
        PDU_设置模块限流点 = 4311,

        枪_通讯状态 = 0,
        枪_充电接口标示 = 5001,
        枪_连接确认开关状态 = 5002,
        枪_输出继电器状态 = 5003,
        枪_停车位车档器状态 = 5004,
        枪_停车位车辆状态 = 5005,
        枪_充电机工作状态 = 5006,
        枪_故障代码 = 5007,
        枪_BMS故障信息 = 5008,
        枪_中止充电原因 = 5009,
        枪_控制模式 = 5010,
        枪_群充策略 = 5011,
        枪_辅助电源类型 = 5012,
        枪_充放电状态 = 5013,
        枪_设备状态 = 5014,
        枪_并网模式 = 5015,
        枪_故障状态1 = 5016,
        枪_故障状态2 = 5017,
        枪_A相电压 = 5300,
        枪_B相电压 = 5301,
        枪_C相电压 = 5302,
        枪_A相电流 = 5303,
        枪_B相电流 = 5304,
        枪_C相电流 = 5305,
        枪_总有功功率 = 5306,
        枪_总无功功率 = 5307,
        枪_总功率因数 = 5308,
        枪_零线电流 = 5309,
        枪_电压不平衡率 = 5310,
        枪_电流不平衡率 = 5311,
        枪_直流侧电压 = 5312,
        枪_直流侧电流 = 5313,
        枪_直流侧功率 = 5314,
        枪_正向有功电能 = 5315,
        枪_正向无功电能 = 5316,
        枪_反向有功电能 = 5317,
        枪_反向无功电能 = 5318,
        枪_BMS需求电压 = 5700,
        枪_BMS需求电流 = 5701,
        枪_当前SOC = 5702,
        枪_最高电池温度 = 5703,
        枪_最高电池电压 = 5704,
        枪_最低电池温度 = 5705,
        枪_最低电池电压 = 5706,
        枪_单体电池最高电压所在编号 = 5707,
        枪_单体电池最高温度所在编号 = 5708,
        枪_单体电池最低温度所在编号 = 5709,
        枪_电池额定容量 = 5710,
        枪_电池额定电压 = 5711,
        枪_动力电池标称总能量 = 5712,
        枪_单体最高允许充电电压 = 5713,
        枪_最高允许充电电流 = 5714,
        枪_最高允许充电总电压 = 5715,
        枪_最高允许温度 = 5716,
        枪_电池类型 = 5801,
        枪_BMS错误报文 = 5802,
        枪_充电机错误报文 = 5803,
        枪_电池生产厂商 = 5901,
        枪_汽车VIN码 = 5902,

        模块_通讯状态 = 0,
        模块_运行状态 = 6001,
        模块_所属分组 = 6002,
        模块_输入A相电压 = 6301,
        模块_输入B相电压 = 6302,
        模块_输入C相电压 = 6303,
        模块_输入电流三相平均电流 = 6304,
        模块_输出电压 = 6305,
        模块_输出电流 = 6306,
        模块_环境温度 = 6307,
        模块_M1板温度 = 6308,
        模块_总运行时间 = 6309,
        模块_切换次数 = 6310,

    }

    public enum EnumModuleState { 待机 = 0, 休眠 = 1, 运行 = 2, 离线 = 3 }

    public enum EnumCCUState { 待机 = 0, 休眠 = 1, 运行 = 2, 离线 = 3, 升级中 = 4 }

    public enum EnumPDUState { 待机 = 0, 休眠 = 1, 离线 = 2, 枪已连接 = 3, 启动中 = 4, 充电中 = 5, 充电结束 = 6 }

    public enum EnumSetting
    {
        设备类型个数 = 1001,
        CAN0通信参数 = 1011,
        CAN1通信参数 = 1012,
        网络通信参数通用设置 = 1020,
        NET0本地网络参数 = 1021,
        NET0服务器设置1 = 1022,
        NET0服务器设置2 = 1023,
        NET0服务器设置3 = 1024,
        NET0服务器设置4 = 1025,
        NET1本地网络参数 = 1026,
        NET1本地服务器有无设置 = 1027,
        NET1服务器设置 = 1028,
        日志参数设置 = 1100,
        刷卡参数设置 = 1111,
        错峰充电峰谷平尖设置 = 1121,
        错峰充电SOC策略设置 = 1122,
        错峰充电电流限值设置 = 1123,
        电表参数设置 = 1131,
        zigbee参数设置 = 1132,
        灯条参数设置 = 1133,
        交流单相模块参数设置1 = 1201,
        交流单相模块参数设置2 = 1202,
        交流三相模块参数设置1 = 1301,
        交流三相模块参数设置2 = 1302,
        直流模块通用静态参数设置 = 1401,
        直流模块通用动态参数设置1 = 1402,
        直流模块通用动态参数设置2 = 1403,
        直流模块通用动态参数设置3 = 1404,
        直流模块主动防护参数设置 = 1405,
        直流模块柔性充电参数设置1 = 1406,
        直流模块柔性充电参数设置2 = 1407,
        直流模块柔性充电参数设置3 = 1408,
        CCU参数设置 = 1501,
    }

    public enum EnumSystemType
    {
        未知 = 0,
        十进一出标准群充系统柜 = 1,
        总控箱4块12慢 = 2,
        四进一出标准群充系统柜 = 3,
        /*4~10：群充预留*/
        接触器版单桩120KW = 11,
        接触器版单桩60KW = 12,
        接触器版单桩30KW = 13,
        PDU版单桩150KW = 14,
        PDU版单桩60KW = 15,
        PDU版单桩上海交投 = 16,
        //17~20：单桩预留
        //21~255：新设备预留
    }

    /// <summary>
    /// 结果
    /// </summary>
    public enum EnumResult { Succeed = 0, Failure = -1 }

    public enum EnumUserRegister { 审批通过 = 0, 未审批 = 1 }

    public enum EnumCardType { 挂失 = 0, 激活 = 1, 未激活 = 2 }
    public enum EnumCardLog { 充值 = 0, 消费 = 1 }

    public enum EnumDeviceGroupType { 集控分组 = 60001 }

    /// <summary>
    /// 控制类型
    /// </summary>
    public enum EnumControlType { Value = 1, String = 2 }

    /// <summary>
    /// 充电类型
    /// </summary>
    public enum EnumChargeType
    {
        立即充电 = 1,
        轮充 = 2,
        限制金额 = 3,
        限制电量 = 4,
        限制时间 = 5,
        经济充电 = 6
    }

    public enum EnumAPIResult { Succeed = 1, Failure = 0 }

    /// <summary>
    /// 各个模块使用的redis数据库号
    /// </summary>
    public enum EnumUserRedisNum { Protocol = 1, Alarm = 2, RealData = 3, Control = 4, Struct = 5, HisData = 6, Sql = 7, Error = 8, EndOrder = 10,Reserve = 12, BMS = 13, WebAPI = 14, WeiXin = 15 }

    /// <summary>
    /// 在小程序中体现本地订单的充电状态
    /// </summary>
    public enum EnumWXOrderState { 未开始 = 0, 充电中 = 1, 充电结束 = 2, 退费完成 = 3 }

    /// <summary>
    /// 移动支付方式  微信小程序直接接微信支付的为0   app通过银联商务接入微信支付为 微信支付24
    /// </summary>

    public enum EnumPaymentType { 小程序微信 = 0, 银商支付宝 = 1, 威富通小程序 = 2, app = 3, 刷卡 = 4, 平台 = 5, 接口 = 6, i电 = 14, 银商小程序 = 20,银商云闪付 = 21, 威富通云闪付 = 22, 威富通微信=23 , 银商微信 = 24,VIN = 30, 微信刷卡 = 40,系统 = 99 }

    public enum EnumRefundType { 普通退款 = 0, 人工操作 = 1 }
    public enum EnumChargeStandardType { 国标2011 = 1, 国标2015 = 2, 两者都有 = 3 }
    public enum EnumAuxiliaryPowerType { 辅源12V = 1, 辅源24V = 2, 两者都有 = 3 }

    public enum EnumStationState { 未知 = 0, 正常 = 1, 告警 = 2, 工程 = 3, 下架 = 4 }

    public enum EnumStationOrderBy { 距离最近 = 1, 评分最高 = 2, 空闲优先 = 3 }

    public enum EnumAPPType { APP = 1, MP = 2 }

    public enum EnumAPPUpdate { 无需更新 = 0, 建议更新 = 1, 强制更新 = 2 }

    public enum EnumAPIStart { 成功 = 1, 设备未连接 = 2, 其他原因失败 = 3 }

    public enum EnumAPIStop { 成功 = 1, 设备不存在 = 2, 设备已离线 = 3, 其他原因失败 = 4 }

    /// <summary>
    /// ID类型
    /// </summary>
    public enum EnumIndexType
    {
        设备ID = 1, 设备Code = 2
    }

    /// <summary>
    /// 设备类型
    /// </summary>
    public enum EnumDeviceType
    {
        集控 = 1, 电表 = 2, CCU = 3, PDU = 4, 充电枪 = 5, 模块 = 6, 逆变器 = 7,
        储能柜 = 8, 储能电池 = 9, DC模块 = 10, 光伏控制柜 = 11, 交流进配电柜 = 12, 总控柜 = 13,
        四象限变换柜 = 14, ACDC模块 = 15, 直流充放电柜 = 16,
        SH充电机 = 50, SH充电枪 = 51
    }
    /// <summary>
    /// 申请发票用户的类型
    /// </summary>
    public enum EnumInvoiceType
    {
        个人 = 0, 企业 = 1
    }
    /// <summary>
    /// 发票类型
    /// </summary>
    public enum InvoiceType
    {
        电子 = 0, 纸质 = 1
    }

    public enum InvoiceState {
        待处理 = 1,已处理 = 2
    }

    public enum EnumTimeStampType
    {
        DeviceTimeStamp = 1,
        TemplateTimeStamp = 2,
        AreaTimeStamp = 3,
        GroupTimmeStamp = 4,
        HisRuleStamp = 5,
        RuleTimeStamp = 6,   //对策略服务的
        AlarmConditionTimeStamp = 7,
        SHDataTimeStamp = 8,
        CardTimeStamp = 9, //卡
        AuthorizationMapTimeStamp = 10 //权限表同步到redis提醒
    }
    //根据厂商 选择支付的方式
    public enum EnumPayChannel
    {
        威富通 = 0,
        微信 = 1,
        银联商务 = 2
    }

    public enum EnumAppName {
        领充 = 1,
        小马 = 2
    }

    public enum EnumPriceType { 电费=1, 服务费=2 }
}
